package cn.com.tenlion.materialstore.service.materiallink;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.materialstore.pojo.dtos.materiallink.MaterialLinkDTO;
import cn.com.tenlion.materialstore.pojo.vos.materiallink.MaterialLinkVO;
import cn.com.tenlion.materialstore.pojo.bos.materiallink.MaterialLinkBO;
import cn.com.tenlion.materialstore.pojo.pos.materiallink.MaterialLinkPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialLinkService
 * @Description: 链接素材
 * @Author: CodeFactory
 * @Date: 2021-05-28 10:54:44
 * @Version: 3.0
 **/
public interface IMaterialLinkService {

    /**
     * 新增链接素材
     *
     * @param materialLinkVO
     * @return
     */
    void save(MaterialLinkVO materialLinkVO);

    /**
     * 新增链接素材
     *
     * @param token
     * @param materialLinkVO
     * @return
     */
    void save(String token, MaterialLinkVO materialLinkVO);

    /**
     * 新增链接素材
     *
     * @param materialLinkVO
     * @return materialLinkId
     */
    String saveReturnId(MaterialLinkVO materialLinkVO);

    /**
     * 新增链接素材
     *
     * @param token
     * @param materialLinkVO
     * @return materialLinkId
     */
    String saveReturnId(String token, MaterialLinkVO materialLinkVO);

    /**
     * 删除链接素材
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除链接素材
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除链接素材（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改链接素材
     *
     * @param materialLinkId
     * @param materialLinkVO
     * @return
     */
    void update(String materialLinkId, MaterialLinkVO materialLinkVO);

    /**
     * 修改链接素材
     *
     * @param token
     * @param materialLinkId
     * @param materialLinkVO
     * @return
     */
    void update(String token, String materialLinkId, MaterialLinkVO materialLinkVO);

    /**
     * 链接素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialLinkDTO get(Map<String, Object> params);

    /**
     * 链接素材详情
     *
     * @param materialLinkId
     * @return
     */
    MaterialLinkDTO get(String materialLinkId);

    /**
     * 链接素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialLinkBO getBO(Map<String, Object> params);

    /**
     * 链接素材详情
     *
     * @param materialLinkId
     * @return
     */
    MaterialLinkBO getBO(String materialLinkId);

    /**
     * 链接素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialLinkPO getPO(Map<String, Object> params);

    /**
     * 链接素材详情
     *
     * @param materialLinkId
     * @return
     */
    MaterialLinkPO getPO(String materialLinkId);

    /**
     * 链接素材列表
     *
     * @param params
     * @return
     */
    List<MaterialLinkDTO> list(Map<String, Object> params);

    /**
     * 链接素材列表
     *
     * @param params
     * @return
     */
    List<MaterialLinkBO> listBO(Map<String, Object> params);

    /**
     * 链接素材列表
     *
     * @param params
     * @return
     */
    List<MaterialLinkPO> listPO(Map<String, Object> params);

    /**
     * 链接素材分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialLinkDTO>> listPage(ListPage page);

    /**
     * 链接素材统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<MaterialLinkDTO> getByMaterialId(String materialId);

    void removeByMaterialId(String materialId);

    void updateCheck(String id);
}